<id>
Default User Font Color for YaBB 2.5
</id>

<version>
0.2
</version>

<mod info>
Description
-----------
This mod will allow users to select a default font color and font weight for their posts on the forum.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Go to Admin Center => Forum Settings => Posting tab to enable the setting.

Files to edit
-------------
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/Profile.lng
Sources/Display.pl
Sources/Post.pl
Sources/Profile.pl
Sources/System.pl

Version History
---------------
V0.1 - First release - 7th May 2012
V0.2 - Added option for users to use bold text as default - 10th May 2012
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/Modlist.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$user_font_color_mod = "Default User Font Color|Derek Barnstorm|This mod will allow users to select a default font color and font weight for their posts on the forum.|0.2|10th May 2012";
	push (@installed_mods, "$user_font_color_mod");
	
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$autolinkurls = $autolinkurls;				# Set to 1 to turn URLs into links, or 0 for no auto-linking.
</search for>

<add after>
\$user_font_color = $user_font_color;    # Set to 1 to allow users to select a default font color for their posts.
\$user_font_weight = $user_font_weight;  # Set to 1 to allow users to use bold text as default for their posts.
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
			name => 'autolinkurls',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			description => qq~<label for="user_font_color">$admin_txt{'user_font_color'}</label>~,
			input_html => qq~<input type="checkbox" name="user_font_color" id="user_font_color" value="1"${ischecked($user_font_color)} />~,
			name => 'user_font_color',
			validate => 'boolean',
		},
		{
			description => qq~<label for="user_font_weight">$admin_txt{'user_font_weight'}</label>~,
			input_html => qq~<input type="checkbox" name="user_font_weight" id="user_font_weight" value="1"${ischecked($user_font_weight)} />~,
			name => 'user_font_weight',
			validate => 'boolean',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'user_font_color' => 'Allow users to select a default font color for their posts?',
'user_font_weight' => 'Allow users to use bold text as default for their posts?',
</add before>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
);

%mycenter_profile_txt = (
</search for>

<add before>
'user_font_color' => 'Choose a default font color for your posts',
'user_font_color_desc' => 'Here you can select a default font color for your posts on the forum.',
'user_font_weight' => 'Use bold text as default for your posts?',
'user_font_weight_desc' => 'Check this option to use bold text as default for your posts on the forum.',
</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		&ToChars($message);
</search for>

<add after>
        my ($mem_font_color, $mem_font_weight);
        if (($user_font_color && ${$uid.$musername}{'user_post_color'}) || ($user_font_weight && ${$uid.$musername}{'user_post_weight'})) {
            if ($user_font_color && ${$uid.$musername}{'user_post_color'}) { $mem_font_color = qq~ color: ${$uid.$musername}{'user_post_color'};~; }
            if ($user_font_weight && ${$uid.$musername}{'user_post_weight'}) { $mem_font_weight = qq~ font-weight: bold;~; }
            $message = qq~<div style="display: inline;$mem_font_color$mem_font_weight">$message</div>~;
        }
</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
		~ if $prevmain;
</search for>

<add after>

        my ($mem_font_color, $mem_font_weight);
        if ($user_font_color && ${$uid.$username}{'user_post_color'}) {
            $mem_font_color = ${$uid.$username}{'user_post_color'};
            $mem_font_color = qq~ color: $mem_font_color;~;
        }
        if ($user_font_weight && ${$uid.$username}{'user_post_weight'}) {
            $mem_font_weight = qq~ font-weight: bold;~;
        }
</add after>

<search for>
			     <div id="saveframe" class="message" style="height:0px; text-align:left; vertical-align:top; overflow:auto;">&nbsp;</div>
</search for>

<replace>
			     <div id="saveframe" class="message" style="height:0px; text-align:left; vertical-align:top; overflow:auto;$mem_font_color$mem_font_weight">&nbsp;</div>
</replace>

<search for>
	require "$templatesdir/$usedisplay/Display.template";

	&ToChars($message);
	$message = &Censor($message);
</search for>

<add after>
    my ($mem_font_color, $mem_font_weight);
    if ($user_font_color && ${$uid.$username}{'user_post_color'}) {
        $mem_font_color = ${$uid.$username}{'user_post_color'};
        $mem_font_color = qq~ color: $mem_font_color;~;
    }
    if ($user_font_weight && ${$uid.$username}{'user_post_weight'}) {
        $mem_font_weight = qq~ font-weight: bold;~;
    }
</add after>

<search for>
		   <div class="message" style="overflow:auto;">$message</div>
</search for>

<replace>
		   <div class="message" style="overflow:auto;$mem_font_color$mem_font_weight">$message</div>
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	</tr>~ if $addmemgroup;
	}
</search for>

<add after>

    if ($user_font_color) {
        $showProfile .= qq~
    <tr class="windowbg">
        <td align="left"><label for="user_font_color"><b>$profile_txt{'user_font_color'}:</b><br /><span class="small">$profile_txt{'user_font_color_desc'}</span></label></td>
        <td align="left" valign="middle">
            <input type="text" size="7" maxlength="7" name="user_font_color" id="user_font_color" value="${$uid.$user}{'user_post_color'}" onkeyup="previewColor(this.value);" /> <span id="user_font_color2" style="background-color: ${$uid.$user}{'user_post_color'}">&nbsp; &nbsp; &nbsp;</span> <img src="$imagesdir/palette1.gif" align="top" style="cursor: pointer" onclick="window.open('$scripturl?action=palette;task=templ', '', 'height=308,width=302,menubar=no,toolbar=no,scrollbars=no')" alt="" border="0" />
            <script language="JavaScript1.2" type="text/javascript">
            <!--
            function previewColor(color) {
                document.getElementById('user_font_color2').style.background = color;
                document.getElementsByName("user_font_color")[0].value = color;
            }
            //-->
            </script>
        </td>
    </tr>~;
	}
	if ($user_font_weight) {
	    if (${$uid.$user}{'user_post_weight'}) { $upw_chk = 'checked="checked"'; }
        $showProfile .= qq~
	<tr class="windowbg">
		<td width="320" align="left"><label for="user_font_weight"><b>$profile_txt{'user_font_weight'}</b><br /><span class="small">$profile_txt{'user_font_weight_desc'}</span></label></td>
		<td align="left"><input type="checkbox" name="user_font_weight" id="user_font_weight" value="1"$upw_chk /></td>
	</tr>~;
	}
</add after>

<search for>
	${$uid.$user}{'signature'} = $member{'signature'};
</search for>

<add after>
	${$uid.$user}{'user_post_color'} = $member{'user_font_color'};
	${$uid.$user}{'user_post_weight'} = $member{'user_font_weight'} ? 1 : 0;
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
	if ($extendedprofiles) {
		require "$sourcedir/ExtendedProfiles.pl";
</search for>

<add before>
	push(@tags, "user_post_color", "user_post_weight");
</add before>
